<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="No. laporan, judul" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                    <el-button @click="showFilterDialog = true" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-funnel"></i> Filter
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button @click="showExportDialog = true" class="margin-small-right" v-permission="[null, 'financialreport', 'create']" size="mini" type="success">
                        <i class="ion-ios-cloud-download"></i> Export
                    </el-button>
                    <el-button v-permission="[null, 'financialreport', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Laporan
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="financialreports" ref="financialreportTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Tanggal"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column                
                label="No. Laporan"
                width="250">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.number }}</span>
                </template>
            </el-table-column>            
            <el-table-column
                label="Judul"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.title }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Periode"
                width="100">
                <template slot-scope="scope">
                    <span>{{ dateFormat(scope.row.period, 'MMMM YYYY') }}</span>
                </template>
            </el-table-column>            
            <el-table-column
                align="right"
                label="Kredit"
                width="150">
                <template slot-scope="scope">
                    <span class="display-block text-align-right" v-if="scope.row.status != 'paid' && scope.row.credit > 0"><strike>Rp. {{ scope.row.credit.format(2,0,',','.') }}</strike></span>
                    <span class="display-block text-align-right" v-else>Rp. {{ scope.row.credit.format(2,0,',','.') }}</span>
                </template>
            </el-table-column>
            <el-table-column
                align="right"
                label="Debit"
                width="150">
                <template slot-scope="scope">
                    <span v-if="scope.row.status != 'paid' && scope.row.debit > 0" class="display-block text-danger text-align-right"><strike>- Rp. {{ scope.row.debit.format(2,0,',','.') }}</strike></span>
                    <span class="display-block text-align-right text-danger" v-else>- Rp. {{ scope.row.debit.format(2,0,',','.') }}</span>
                </template>
            </el-table-column>            
            <el-table-column
                align="right"
                label="Saldo"
                width="150">
                <template slot-scope="scope">
                    <span v-if="scope.row.status == 'paid'" class="display-block text-align-right">Rp. {{ scope.row.balance.format(2,0,',','.') }}</span>
                    <span v-else class="display-block text-align-right"><strike>Rp. {{ scope.row.balance.format(2,0,',','.') }}</strike></span>
                </template>
            </el-table-column>
            <el-table-column
                label="Status"
                width="100">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.status == 'paid'" type="success" size="mini">Lunas</el-tag>
                    <el-tag v-else-if="scope.row.status == 'unpaid'" type="danger" size="mini">Belum Lunas</el-tag>
                    <el-tag v-else type="info" size="mini">Menunggu Persetujuan</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'financialreport', 'viewown']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'financialreport', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                    <el-button class="text-info" v-permission="[row, 'financialreport', 'viewown']" type="text" @click="handleDownload(row)">Tanda Terima</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="exportLoading" title="Export Laporan Keuangan" :visible.sync="showExportDialog" width="30%" :show-close="false" @closed="resetForm">
            <aside>
                <el-alert type="info" description="Download data laporan keuangan berdasarkan kriteria di bawah" :closable=false show-icon></el-alert>
            </aside>
            <el-form ref="export" :model="exportPDF">
                <el-form-item label="Perumahan" prop="residential" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                    <el-select v-model="exportPDF.residential" placeholder="Pilih perumahan" class="width-100" ref="residential" name="residential" @change="handleResidentialExportChange">
                        <el-option
                            v-for="item in residentials"
                            :key="item.id"
                            :label="item.name"
                            :value="item.id">
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="Periode" prop="period">
                    <el-date-picker
                        format="yyyy-MM" 
                        value-format="yyyy-MM-dd" 
                        :clearable="false" 
                        :editable="false"
                        :default-value="exportPDF.period"
                        v-model="exportPDF.period"
                        type="month"
                        placeholder="Pilih bulan">
                    </el-date-picker>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showExportDialog = false" size="medium">Batal</el-button>
                <el-button @click="handleExport" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> Submit
                </el-button>
            </span>
        </el-dialog>

        <el-dialog v-loading="filterLoading" title="Filter" :visible.sync="showFilterDialog" width="30%" :show-close="false" @closed="resetForm">
            <aside>
                <el-alert type="info" description="Tampilkan data laporan keuangan berdasarkan kriteria di bawah" :closable=false show-icon></el-alert>
            </aside>
            <el-form ref="filter" :model="filter">
                <el-form-item label="Kata Kunci" prop="keyword">
                    <el-input ref="keyword" name="keyword" v-model="filter.keyword" placeholder="Nama pengguna, no. handphone" autocomplete="off" maxlength="255" clearable></el-input>
                </el-form-item>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Jenis Transaksi" prop="trx_type">
                            <el-select v-model="filter.trx_type" placeholder="Pilih jenis transaksi" class="width-100" ref="trx_type" name="trx_type" clearable>
                                <el-option
                                    v-for="item in trxType"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Periode" prop="period">
                            <el-date-picker
                                format="yyyy-MM" 
                                value-format="yyyy-MM-dd" 
                                :clearable="false" 
                                :editable="false"
                                :default-value="filter.period"
                                v-model="filter.period"
                                type="month"
                                placeholder="Pilih bulan">
                            </el-date-picker>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Kategori" prop="category">
                            <el-select v-model="filter.category" placeholder="Pilih kategori" class="width-100" ref="category" name="category" clearable>
                                <el-option
                                    v-for="item in categories"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Terima Dari" prop="author" clearable>
                            <el-select 
                                v-model="filter.author" 
                                placeholder="Ketik nama warga" 
                                class="width-100" 
                                ref="author" 
                                name="author"
                                clearable
                                filterable
                                remote
                                :remote-method="getUsers"
                                value-key="id"
                                >
                                <el-option
                                    v-for="item in users"
                                    :key="item.id"
                                    :label="item.profile.fullname"
                                    :value="item.id">
                                    <span style="float: left">{{ item.profile.fullname }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.role.name }}</strong>
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Status Transaksi" prop="status">
                            <el-select v-model="filter.status" placeholder="Pilih status transaksi" class="width-100" ref="status" name="status">
                                <el-option
                                    v-for="item in trxStatus"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                        <el-form-item label="Perumahan" prop="residential">
                            <el-select v-model="filter.residential" placeholder="Pilih perumahan" class="width-100" ref="residential" name="residential">
                                <el-option
                                    v-for="item in residentials"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>                
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showFilterDialog = false" size="medium">Batal</el-button>
                <el-button @click="handleSearch" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> Submit
                </el-button>
            </span>
        </el-dialog>

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="financialreportForm" :model="financialreportForm" :rules="financialreportRules">
                <aside>
                    <el-alert type="info" description="Mengatur daftar semua aliran kas keuangan untuk masing-masing perumahan." :closable=false show-icon></el-alert>
                </aside>
                <el-form-item label="Judul Laporan" prop="title">
                    <el-input ref="title" name="title" v-model="financialreportForm.title" placeholder="Judul laporan" autocomplete="off" maxlength="255" show-word-limit></el-input>
                </el-form-item>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Jenis Transaksi" prop="trx_type">
                            <el-select @change="handleTrxTypeChange" v-model="financialreportForm.trx_type" placeholder="Pilih jenis transaksi" class="width-100">
                                <el-option
                                    v-for="item in trxType"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Kategori" prop="category">
                            <el-select v-model="financialreportForm.category" placeholder="Pilih kategori" class="width-100" ref="category" name="category">
                                <el-option
                                    v-for="item in categories"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Periode" prop="period">
                            <el-date-picker
                                format="yyyy-MM" 
                                value-format="yyyy-MM-dd" 
                                :clearable="false" 
                                :editable="false"
                                :default-value="filter.period"
                                v-model="filter.period"
                                type="month"
                                placeholder="Pilih bulan">
                            </el-date-picker>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Jumlah" prop="nominal">
                            <el-input type="number" ref="nominal" name="nominal" v-model="financialreportForm.nominal" placeholder="0.00" autocomplete="off" min="0">
                                <template slot="prepend">Rp</template>
                            </el-input>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                        <el-form-item label="Warga Perumahan" prop="residential">
                            <el-select @change="handleResidentialChange" v-model="financialreportForm.residential" placeholder="Pilih perumahan" class="width-100" ref="residential" name="residential">
                                <el-option
                                    v-for="item in residentials"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>                   
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Status Transaksi" prop="status">
                            <el-select v-model="financialreportForm.status" placeholder="Pilih status transaksi" class="width-100" ref="status" name="status">
                                <el-option
                                    v-for="item in trxStatus"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Terima Dari" prop="author">
                            <el-select 
                                :disabled="financialreportForm.residential == null"
                                v-model="financialreportForm.author" 
                                placeholder="Ketik nama warga" 
                                class="width-100" 
                                ref="author" 
                                name="author"
                                clearable
                                filterable
                                remote
                                :remote-method="getUsers"
                                value-key="id"
                                >
                                <el-option
                                    v-for="item in users"
                                    :key="item.id"
                                    :label="item.profile.fullname"
                                    :value="item.id">
                                    <span style="float: left">{{ item.profile.fullname }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.role.name }}</strong>
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Penerima" prop="recepient">
                            <el-input ref="recepient" name="recepient" v-model="financialreportForm.recepient" placeholder="Nama penerima" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-form-item label="Catatan" prop="note">
                    <el-input type="textarea" ref="note" name="note" v-model="financialreportForm.note" placeholder="Catatan" autocomplete="off" maxlength="255" :autosize="{ minRows: 2, maxRows: 4}" show-word-limit></el-input>
                </el-form-item>
                <h3>Ditandatangani Oleh:</h3> 
                <div v-for="(item, index) of financialreportForm.signedby" :key="index" class="dynamic-list">
                    <el-row :gutter="20">
                        <el-col :lg="12" :md="24" :sm="24">
                            <el-form-item label="Nama" :prop="item.name">
                                <el-input ref="name" name="name" v-model="item.name" placeholder="Nama lengkap" autocomplete="off" maxlength="255" show-word-limit></el-input>
                            </el-form-item> 
                        </el-col>
                        <el-col :lg="12" :md="24" :sm="24">
                            <el-form-item label="Jabatan" :prop="item.position">
                                <el-input ref="position" name="position" v-model="item.position" placeholder="Jabatan/Posisi" autocomplete="off" maxlength="255" show-word-limit></el-input>
                            </el-form-item> 
                        </el-col>
                    </el-row>
                    <el-form-item>
                        <el-button class="float-right margin-small-left" @click="deleteAction(index)" v-if="index > 0" icon="el-icon-delete" type="danger" size="mini">Hapus</el-button>
                        <el-button class="float-right" @click="addAction" v-if="(index + 1) == financialreportForm.signedby.length" icon="el-icon-plus" type="success" size="mini"> Tambah</el-button>                        
                    </el-form-item>
                </div>
                <el-form-item label="" prop="medias">
                    <el-upload
                        name="media"
                        :action="uploadURL"
                        with-credentials
                        accept=" .jpg, .jpeg, .png, .doc, .docx, .xls, .xlsx, .pdf"
                        :headers="{'Authorization': 'Bearer ' + token.access_token}"
                        :on-success="handleUploadSuccess"
                        :on-remove="handleUploadRemove"
                        :before-upload="beforeUpload"
                        :file-list="uploadFileList">
                        <el-button size="small" type="primary">Lampiran</el-button>
                        <div slot="tip" class="el-upload__tip">Tipe file: jpg, png, doc/docx, xls/xlsx, pdf</div>
                    </el-upload>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'financialreport', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import html2pdf from 'html2pdf.js';
import moment from 'moment';
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight, spelledOut } from '@/utils/index';

export default {
    name: 'FinancialReport',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        var validateAuthor = (rule, value, callback) => {
            if(this.financialreportForm.trx_type == 'credit' && this.financialreportForm.residential != null && this.financialreportForm.author == null){
                return callback(new Error('Terima dari wajib dipilih.'));
            }
            callback();
        };

        var validateRecepient = (rule, value, callback) => {
            if(this.financialreportForm.trx_type == 'debit' && this.financialreportForm.recepient.trim().length == 0){
                return callback(new Error('Nama penerima wajib diisi.'));
            }
            callback();
        };

        return {
            tableLoading: false,
            dialogLoading: false,
            filterLoading: false,
            exportLoading: false,
            filter: {
                keyword: '',
                trx_type: null,
                status: null,
                period: new Date(),
                author: null,
                residential: null,
                category: null
            },
            exportPDF: {
                residential: null,
                period: new Date(),
                selectedResidential: null
            },
            showDialog: false,
            showFilterDialog: false,
            showExportDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Laporan',
                create: 'Tambah Laporan'
            },
            trxType: [{
                label: 'Kredit',
                value: 'credit'
            }, {
                label: 'Debit',
                value: 'debit'
            }],
            trxStatus: [{
                label: 'Menunggu Konfirmasi',
                value: 'waiting'
            }, {
                label: 'Belum Lunas',
                value: 'unpaid'
            }, {
                label: 'Lunas',
                value: 'paid'
            }],
            financialreportForm: {
                id: null,
                trx_type: '',
                title: '',
                nominal: 0,
                recepient: '',
                period: new Date(),
                note: '',
                status: 'waiting',
                archived: false,
                residential: null,
                category: null,
                author: null,
                medias: [],
                signedby: [{
                    name: '',
                    position: ''
                }]
            },
            financialreportRules: {
                title: [{ 
                    required: true, message: 'Judul laporan wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang judul laporan maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                trx_type: [{
                    required: true, message: 'Jenis transaksi wajib dipilih', trigger: 'change'
                }],
                category: [{
                    required: true, message: 'Kategori laporan wajib dipilih', trigger: 'change'
                }],
                period: [{
                    required: true, message: 'Periode pembayaran laporan wajib dipilih', trigger: 'change'
                }],
                nominal: [{
                    required: true, message: 'Jumlah pembayaran laporan wajib diisi', trigger: 'blur'
                }],
                residential: [{
                    required: true, message: 'Warga perumahan wajib dipilih', trigger: 'change'
                }],
                status: [{
                    required: true, message: 'Status transaksi wajib dipilih', trigger: 'change'
                }],
                author: [{
                    validator: validateAuthor, trigger: 'change'
                }],
                recepient: [{
                    validator: validateRecepient, trigger: 'change'
                }],
                description: [{ max: 255, message: 'Panjang deskripsi maksimal 255 karakter', trigger: 'blur'}]
            },
            uploadFileList: [],
            uploadURL: ''
        };
    },
    computed: {
        spelledOut,
        tableHeight,
        ...mapGetters('auth', ['token']),
        ...mapGetters('user', ['me', 'users']),
        ...mapGetters('category', ['categories']),
        ...mapGetters('residential', ['residentials']),
        ...mapGetters('financialreport', [
            'financialreports',
            'pagination'
        ]),
    },
    created() {
        this.getFinancialReports();
        this.getCategories();
        this.getResidentials();
    },
    methods: {
        playSound,
        dateFormat,
        getFinancialReports() {
            this.tableLoading = true;
            this.$store.dispatch('financialreport/getFinancialReports', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getCategories() {
            this.tableLoading = true;
            this.$store.dispatch('category/getCategories', {
                module: 'financialreport',
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getResidentials() {
            this.tableLoading = true;
            this.$store.dispatch('residential/getResidentials', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getUsers(q) {
            if(q.trim().length >= 3){
                this.tableLoading = true;
                this.$store.dispatch('user/getUsers', {
                    q: q,
                    residential: this.financialreportForm.residential,
                    page: this.pagination.page,
                    perpage: this.pagination.perpage
                }).then(() => {
                    this.tableLoading = false;
                });
            }
        },
        handleSearch(){

            this.showFilterDialog = false;

            let payload = {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }

            if(this.filter.trx_type != null){
                payload['trx_type'] = this.filter.trx_type;
            }

            if(this.filter.period != null){
                payload['period'] = this.filter.period;
            }

            if(this.filter.status != null){
                payload['status'] = this.filter.status;
            }

            if(this.filter.residential != null){
                payload['residential'] = this.filter.residential;
            }

            if(this.filter.author != null){
                payload['author'] = this.filter.author;
            }

            if(this.filter.category != null){
                payload['category'] = this.filter.category;
            }


            this.tableLoading = true;
            this.$store.dispatch('financialreport/getFinancialReports', payload).then(() => {
                this.tableLoading = false;
            });
        },
        handleExport(){

            this.showExportDialog = false;

            let payload = {
                status: 'paid',
                page: this.pagination.page,
                perpage: 100
            }

            if(this.exportPDF.period != null){
                payload['period'] = this.exportPDF.period;
            }

            if(this.exportPDF.residential != null){
                payload['residential'] = this.exportPDF.residential;
            }

            this.tableLoading = true;
            this.$store.dispatch('financialreport/getFinancialReports', payload).then(() => {
                this.tableLoading = false;
                this.handleExportDownload();
            });
        },
        handleResidentialExportChange(value){
            if(value){
                this.residentials.filter((x) => {
                    if(x.id == value){
                        this.exportPDF.selectedResidential = x;
                    }
                });                
            }   
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;     
            this.uploadURL = 'http://api.ringsatu.id/v1/media/tmp';     
            
            if(['root', 'owner'].indexOf(this.me.role.slug) == -1){
                this.financialreportForm.residential = this.me.residential.id;
            }

            this.$nextTick(() => {
                this.$refs['financialreportForm'].clearValidate();
            });
        },
        handleEdit(financialreport){

            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.uploadURL = 'http://api.ringsatu.id/v1/media/financialreport/'+financialreport.id
            this.financialreportForm.id = financialreport.id;
            this.financialreportForm.trx_type = financialreport.trx_type;
            this.financialreportForm.title = financialreport.title;
            this.financialreportForm.recepient = financialreport.recepient;
            this.financialreportForm.period = financialreport.period;
            this.financialreportForm.nominal = financialreport.trx_type == 'credit' ? financialreport.credit : financialreport.debit;
            this.financialreportForm.note = financialreport.note;  
            this.financialreportForm.status = financialreport.status;            
            this.financialreportForm.residential = financialreport.residential.id;
            this.financialreportForm.category = financialreport.category.id;
            this.financialreportForm.archived = financialreport.archived;

            if(financialreport.signs.length){
                this.financialreportForm.signedby = [];
                for(const x of financialreport.signs){
                    this.financialreportForm.signedby.push({
                        name: x.name,
                        position: x.position
                    });
                }
            }

            if(financialreport.trx_type != 'debit'){
                this.financialreportForm.author = financialreport.author.id;
            }

            if(financialreport.medias != null){
                for(const i of financialreport.medias){
                    this.financialreportForm.medias.push(i.id);
                    this.uploadFileList.push({
                        id: i.id,
                        name: i.original_filename
                    });
                }
            }else{
                this.financialreportForm.medias = financialreport.medias;
            }           

            this.getUsers(financialreport.author.profile.fullname);

            this.$nextTick(() => {
                this.$refs['financialreportForm'].clearValidate()
            });     
        },
        handleTrxTypeChange(value){
            if(!value || value == 'debit'){
                this.financialreportForm.author = null;
            }else if(value == 'credit'){
                this.financialreportForm.recepient = '';
            }
        },
        handleResidentialChange(value){
            if(!value){
                this.financialreportForm.author = null;
            }
        },
        handleDownload(row){
            moment.locale('id');

            var nominal = row.trx_type == 'credit' ? row.credit : row.debit,
                nominal_formatted = nominal.format(2,0,',','.'),
                spelledout = spelledOut(nominal) + ' rupiah',
                payer = row.trx_type == 'credit' ? row.recepient : row.author.profile.fullname;

            
            var html = '<div id="pdf" style="font-size:13px!important;line-height:1.6em;">';

            html += '<table style="width:100%;">'+
                        '<tr>'+
                            '<td style="width: 25%;" valign="top">'+
                                '<img src="http://my.ringsatu.id/logo-text-only.png" width="200">'+                                          
                            '</td>'+
                            '<td style="width: 75%;" valign="top" align="right">'+
                                '<strong>'+row.residential.name+'</strong><br>'+
                                '<small>'+row.residential.address+' '+row.residential.administrative_region[0]+', '+row.residential.administrative_region[1]+', '+row.residential.administrative_region[2]+',<br>'+
                                row.residential.administrative_region[3]+', '+row.residential.administrative_region[4]+'</small>'+
                            '</td>'+
                        '</tr>'+
                    '</table>'+
                    '<strong style="display:block;text-align:center;margin:50px 0;font-size: 20px;">TANDA TERIMA</strong>'+
                    '<table style="width:100%;margin-top:50px;">'+
                        '<tr>'+
                            '<td style="width: 25%;padding:15px 0;" valign="top">'+
                                '<strong>Nomor</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:15px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: '+row.number+'</span>'+         
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:15px 0;" valign="top">'+
                                '<strong>Telah Terima Dari</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:15px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>'+payer+'</span>'+
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:15px 0;" valign="top">'+
                                '<strong>Uang Sejumlah</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:15px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: Rp. '+nominal_formatted+'</span>'+                
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:15px 0;" valign="top">'+
                                '<strong>Terbilang</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:15px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: '+spelledout+'</span>'+         
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:15px 0;" valign="top">'+
                                '<strong>Untuk Pembayaran</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:15px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: '+row.title+'</span>'+             
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td style="width: 25%;padding:15px 0;" valign="top">'+
                                '<strong>Catatan</strong><br>'+
                            '</td>'+
                            '<td style="width: 75%;padding:15px 0;border-bottom: 1px dotted #ddd;" valign="top">'+
                                '<span>: '+(row.note || "-")+'</span>'+             
                            '</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td colspan="2" style="padding:10px 0;">&nbsp;</td>'+
                        '</tr>'+
                        '<tr>'+
                            '<td colspan="2" style="width: 100%;padding:20px 30px;font-size: 20px;border: 1px solid #ddd;background: #eee;" valign="center">'+
                                '<strong>Jumlah : Rp. '+nominal_formatted+' </strong><br>'+
                            '</td>'+
                        '</tr>'+
                        '</table>'+
                        '<table style="width:100%;margin-top:50px;">'+
                            '<tr>'+
                                '<td style="width: 100%;" valign="top">'+
                                    '<strong>'+row.residential.administrative_region[2].replace(/(Kota|Kab)/g, '')+', '+moment(row.updated).format('DD MMMM YYYY')+'</strong>'+ 
                                '</td>'+
                            '</tr>'+
                        '</table>';

                    if(row.signs.length){                        
                        html += '<table style="width:100%;margin-top:50px;">'+
                                '<tr>';

                            var percent = (100/row.signs.length);
                            
                            for(const x of row.signs){
                                    html += '<td style="width: '+percent+'%;">'+
                                        '<span style="text-align:center;">'+
                                            '<u>'+x.name+'</u><br>'+ x.position +
                                        '</span>'+                  
                                    '</td>';
                            }
                        html += '</tr>'+
                            '</table>';
                    }

                    html += '<br>'+
                        '<small>Tanda terima ini merupakan bukti pembayaran yang sah antara kedua belah pihak.</small>'+
                    '</div>';

            var opt = {
                margin: 1,
                filename: row.title+'.pdf',
                image: { type: 'jpeg', quality: 0.98 },
                pagebreak: { mode: ['avoid-all', 'css', 'legacy'] },
                html2canvas: { scale: 2 },
                jsPDF: { unit: 'in', format: 'a4', orientation: 'portrait' }
            };

            // New Promise-based usage:
            html2pdf().set(opt).from(html).save();

        },
        handleExportDownload(){
            var reports = this.financialreports,
                residential = this.exportPDF.selectedResidential,
                period = moment(this.exportPDF.period).format('MMMM YYYY').toUpperCase();


            var html = '<div id="pdf" style="font-size:13px!important;line-height:1.6em;">';

            html += '<table style="width:100%;">'+
                        '<tr>'+
                            '<td style="width: 25%;" valign="top">'+
                                '<img src="http://my.ringsatu.id/logo-text-only.png" width="200">'+                                          
                            '</td>';

                    if(residential != null){
                        html += '<td style="width: 75%;" valign="top" align="right">'+
                                '<strong>'+residential.name+'</strong><br>'+
                                '<small>'+residential.address+' '+residential.administrative_region[0]+', '+residential.administrative_region[1]+', '+residential.administrative_region[2]+',<br>'+
                                residential.administrative_region[3]+', '+residential.administrative_region[4]+'</small>'+
                            '</td>';
                    }

            html +=     '</tr>'+
                    '</table>'+
                    '<strong style="display:block;text-align:center;margin:50px 0;font-size: 20px;">LAPORAN KEUANGAN '+period+'</strong>'+
                    '<table style="width:100%;">'+
                        '<thead>'+
                            '<tr>'+
                                '<th valign="top" align="left" style="text-align:left;width: 15%;"><strong>Tanggal</strong></th>'+
                                '<th valign="top" align="left" style="text-align:left;width: 25%;"><strong>Judul</strong></th>'+
                                '<th valign="top" align="right" style="text-align:right;width: 20%;"><strong>Kredit (Rp)</strong></th>'+
                                '<th valign="top" align="right" style="text-align:right;width: 20%;"><strong>Debit (Rp)</strong></th>'+
                                '<th valign="top" align="right" style="text-align:right;width: 20%;"><strong>Saldo (Rp)</strong></th>'+
                            '</tr>'
                        '</thead>'+
                        '<tbody>';

            var total_credit = 0,
                total_debit = 0,
                total_balance = 0,
                counter = 0;

            for(const x of reports){

                total_credit = (total_credit + x.credit);
                total_debit = (total_debit + x.debit);

                html += '<tr>'+
                            '<td valign="top" align="left" style="padding:5px 0;text-align:left;width: 15%;">'+dateFormat(x.updated, 'DD/MM/YYYY')+'</td>'+
                            '<td valign="top" align="left" style="padding:5px 0;text-align:left;width: 25%;">'+x.title+'</td>'+
                            '<td valign="top" align="right" style="padding:5px 0;text-align:right;width: 20%;">'+x.credit.format(2,0,',','.')+'</td>'+
                            '<td valign="top" align="right" style="padding:5px 0;text-align:right;width: 20%;">-'+x.debit.format(2,0,',','.')+'</td>'+
                            '<td valign="top" align="right" style="padding:5px 0;text-align:right;width: 20%;">'+x.balance.format(2,0,',','.')+'</td>'+
                        '</tr>';

                if((counter+1) == reports.length){
                    total_balance = x.balance;
                }

                counter++;
            }

            html +=     '</tbody>'+
                        '<tfoot>'+
                            '<tr>'+
                                '<td valign="top" align="right" colspan="3" style="padding:5px 0;border-top:1px solid #ddd;text-align:right;width: 60%;"><strong>'+total_credit.format(2,0,',','.')+'</strong></td>'+
                                '<td valign="top" align="right" style="padding:5px 0;border-top:1px solid #ddd;text-align:right;width: 20%;"><strong>'+total_debit.format(2,0,',','.')+'</strong></td>'+
                                '<td valign="top" align="right" style="padding:5px 0;border-top:1px solid #ddd;text-align:right;width: 20%;"><strong>'+total_balance.format(2,0,',','.')+'</strong></td>'+
                            '</tr>'+    
                        '</tfoot>'+   
                    '</table>';
                    
                html += '<br>'+
                    '<small>*Data laporan keuangan di atas tidak termasuk hutang dan piutang</small>'+
                    '</div>';

            var opt = {
                margin: 1,
                filename: 'Laporan Keuangan '+period+'.pdf',
                image: { type: 'jpeg', quality: 0.98 },
                pagebreak: { mode: ['avoid-all', 'css', 'legacy'] },
                html2canvas: { scale: 2 },
                jsPDF: { unit: 'in', format: 'a4', orientation: 'landscape' }
            };

            // New Promise-based usage:
            html2pdf().set(opt).from(html).save();

        },
        handleSubmit(){
            this.$refs.financialreportForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'financialreport/addFinancialReport';
                        payload = {
                            trx_type: this.financialreportForm.trx_type,
                            title: this.financialreportForm.title,
                            recepient: this.financialreportForm.recepient,
                            period: this.financialreportForm.period,
                            nominal: this.financialreportForm.nominal,
                            note: this.financialreportForm.note,
                            status: this.financialreportForm.status,
                            author: this.financialreportForm.author,
                            residential: this.financialreportForm.residential,
                            category: this.financialreportForm.category,
                            archived: this.financialreportForm.archived,
                            medias: this.financialreportForm.medias,
                            signedby: this.financialreportForm.signedby
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'financialreport/editFinancialReport';
                        payload = {
                            id: this.financialreportForm.id,
                            trx_type: this.financialreportForm.trx_type,
                            title: this.financialreportForm.title,
                            recepient: this.financialreportForm.recepient,
                            period: this.financialreportForm.period,
                            nominal: this.financialreportForm.nominal,
                            note: this.financialreportForm.note,
                            status: this.financialreportForm.status,
                            author: this.financialreportForm.author,
                            residential: this.financialreportForm.residential,
                            category: this.financialreportForm.category,
                            archived: this.financialreportForm.archived,
                            medias: this.financialreportForm.medias,
                            signedby: this.financialreportForm.signedby
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }                        
                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(financialreport){
            this.$confirm('Anda mencoba untuk menghapus data laporan keuangan, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('financialreport/deleteFinancialReport', {
                    id: financialreport.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.financialreportForm = {
                id: null,
                trx_type: '',
                title: '',
                nominal: 0,
                recepient: '',
                period: new Date(),
                note: '',
                status: 'waiting',
                archived: false,
                residential: null,
                category: null,
                author: null,
                medias: [],
                signedby: [{
                    name: '',
                    position: ''
                }]
            }

            this.uploadFileList = [];
        },
        beforeUpload(file) {
            if (['image/jpeg', 'image/png', 'application/pdf', 'application/msword', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'application/vnd.ms-excel', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet', 'application/wps-office.docx', 'application/wps-office.doc', 'application/wps-office.xlsx', 'application/wps-office.xls',].indexOf(file.type) < 0) {
                this.$message.error('Hanya image dengan tipe file jpg, png, doc/docx, xls/xlsx dan pdf yang diperbolehkan.');
                return false;
            }
            if (file.size > (8 * 1024 * 1024)) {
                this.$message.error('Ukuran file tidak boleh lebih dari 8MB.');
                return false;
            }
            return true;
        },
        handleUploadSuccess(res) {
            this.financialreportForm.medias.push(res.data.media.id);
            this.uploadFileList.push({
                name: res.data.media.original_filename,
                id: res.data.media.id
            });
        },
        handleUploadRemove(file){

            for(const i of this.uploadFileList){
                if(i.id === file.id){
                    this.uploadFileList.splice(i, 1);
                    break;
                }
            }

            let action = '';
            let params = {};

            if(this.dialogStatus == 'create'){
                action = 'media/deleteMediaTmp';
                params.id = file.id;
            }else{
                action = 'media/deleteMedia';
                params.id = file.id;
                params.endpoint = 'financialreport';
            }

            this.$store.dispatch(action, params).then((response) => {
                if('errors' in response){
                    let error = parseError(response.errors);
                    this.$message.error({
                        message: error.messages
                    });
                }else{
                    this.$message.success({
                        message: response.message
                    });
                }

                this.playSound();
            });
        },

        addAction() {
            this.financialreportForm.signedby.push({
                name: '',
                position: ''
            });
        },
        deleteAction(index) {
            for(const [i, v] of this.financialreportForm.signedby.entries()){
                if(i == index){
                    this.financialreportForm.signedby.splice(i, 1);                    
                    break;
                }
            }
        }
    }

}
</script>
